package forum;


import exceptions.*;
import util.Mensagem;

import java.util.Vector;
import java.sql.SQLException;




public interface ICadastroForum  {


	

	
	public void adicionarForum(Forum f) throws ObjetoNuloException,SQLException;
	
	public void adicionarAssunto(int id_forum, Assunto a) 
	  throws ObjetoNuloException,ForumNaoExistenteException,SQLException;
	
	
	public void adicionarTopico(int id_forum, int id_assunto, Topico t) 
	  throws ObjetoNuloException,ForumNaoExistenteException,AssuntoNaoExistenteException,SQLException;
	
	
	public void adicionarMensagemTopico(int id_forum, int id_assunto,int id_topico, Mensagem m) 
	  throws ObjetoNuloException,ForumNaoExistenteException,AssuntoNaoExistenteException,
	  TopicoNaoExistenteException,SQLException;
		

	
	public boolean existeForum(int id_forum) throws SQLException;
	
	public boolean existeAssunto(int id_forum, int id_assunto) throws SQLException;
	
	public boolean existeTopico(int id_forum, int id_assunto, int id_topico) throws SQLException;
	
	public boolean existeMensagemTopico(int id_forum, int id_assunto, int id_topico,int id_mensagem) throws SQLException;
	
	
	
	
	
	
	public Vector getForuns() throws SQLException;
	
	public Vector getTopicosAssunto(int id_forum,int id_assunto) throws SQLException;
	public Vector getMensagensTopico(int id_forum,int id_assunto,int id_topico) throws SQLException;
	
	
	public Forum procurarForum(int id_forum) throws ForumNaoExistenteException,SQLException;
	
	public Assunto procurarAssunto(int id_forum,int id_assunto) throws AssuntoNaoExistenteException,SQLException;
	
	public Topico procurarTopico(int id_forum,int id_assunto,int id_topico) throws TopicoNaoExistenteException,SQLException;
		
	public Mensagem procurarMensagemTopico(int id_forum,int id_assunto,int id_topico,int id_mensagem) 
	   throws MensagemTopicoNaoExistenteException,SQLException;
	
	
	
	
	public void atualizarForum(Forum f) throws ObjetoNuloException,ForumNaoExistenteException,SQLException;
	
	public void atualizarAssunto(int id_forum,Assunto a) throws ObjetoNuloException,AssuntoNaoExistenteException,SQLException;
		
	public void atualizarTopico(int id_forum,int id_assunto,Topico t) throws ObjetoNuloException,TopicoNaoExistenteException,SQLException;
	
	public void atualizarMensagemTopico(int id_forum,int id_assunto, int id_topico,Mensagem m) 
	  throws ObjetoNuloException,MensagemTopicoNaoExistenteException,SQLException;
	
	

	public void moverTopico (int id_forum,int id_assunto, int id_topico) 
	  throws AssuntoNaoExistenteException,TopicoNaoExistenteException,SQLException;
	
	
	
	
	
	public void removerForum(int id_forum) throws ForumNaoExistenteException,SQLException;
	
	public void removerAssunto(int id_forum,int id_assunto) throws AssuntoNaoExistenteException,SQLException;
	
	
	public void removerTopico(int id_forum,int id_assunto,int id_topico) throws TopicoNaoExistenteException,SQLException;
	
	
	public void removerMensagemTopico(int id_forum,int id_assunto,int id_topico,int id_mensagem) throws MensagemTopicoNaoExistenteException,SQLException;

}
	