package projeto;


import exceptions.*;
import util.Mensagem;

import java.util.Vector;
import java.sql.SQLException;



public interface ICadastroProjeto {

	
	
	public Vector getProjetos() throws SQLException;
	
	public Vector getProjetosAdministrados(int id_usuario) throws UsuarioNaoExistenteException,SQLException; 
	
	public Vector getProjetosMembro(int id_usuario) throws UsuarioNaoExistenteException,SQLException;
	
	public Vector getAdministradoresProjeto(int id_projeto) throws ProjetoNaoExistenteException,SQLException;
		
	public Vector getMembrosProjeto(int id_projeto) throws ProjetoNaoExistenteException,SQLException;
	
	public Projeto procurarProjeto(int id_projeto) throws ProjetoNaoExistenteException,SQLException;	
		
	public boolean existeProjeto(int id_projeto) throws SQLException;		
	
			
	
	public Projeto adicionarProjeto(Projeto p) throws ObjetoNuloException,AutorNaoExistenteException,SQLException;
	
	public void atualizarProjeto(Projeto p) throws ObjetoNuloException,ProjetoNaoExistenteException,SQLException;

	public void removerProjeto(int id_projeto) throws ObjetoNuloException,ProjetoNaoExistenteException,SQLException;

	
	
	public Vector getEsperaProjeto(int id_projeto) throws ProjetoNaoExistenteException,SQLException;
	
	
	public void adicionarEsperaProjeto(int id_projeto, int id_usuario)
	  throws ProjetoNaoExistenteException,UsuarioNaoExistenteException,SQLException;
	
	
	public void removerEsperaProjeto(int id_projeto, int id_usuario)
	  throws ProjetoNaoExistenteException,UsuarioNaoExistenteException,SQLException;
	
	
	
	public void adicionarParticipante(int id_projeto,int id_usuario) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,UsuarioNaoExistenteException,
	  MembroExistenteException,SQLException;
	
	
	public void adicionarAdministrador(int id_projeto,int id_usuario) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,UsuarioNaoExistenteException,
	  AdministradorNaoMembroException,AdministradorExistenteException,SQLException;

		
	public void removerParticipanteProjeto(int id_projeto,int id_usuario) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,UsuarioNaoExistenteException,
	  MembroNaoExistenteException,SQLException;	
	
	
	public void removerAdministradorProjeto(int id_projeto,int id_usuario) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,UsuarioNaoExistenteException,
	  AdministradorNaoExistenteException,SQLException;

	
		
	public void adicionarComentarioProjeto(int id_projeto, Mensagem m) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,MensagemNaoExistenteException,
	  AutorNaoExistenteException,SQLException;

	
	public void adicionarRecadoProjeto(int id_projeto, Mensagem m) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,MensagemNaoExistenteException,
	  AutorNaoExistenteException,SQLException;

	
	public void removerComentarioProjeto(int id_projeto, Mensagem m) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,MensagemNaoExistenteException,
	  ComentarioNaoExistenteException,SQLException;

		
	public void removerRecadoProjeto(int id_projeto, Mensagem m) 
	  throws ObjetoNuloException,ProjetoNaoExistenteException,MensagemNaoExistenteException,
	  RecadoNaoExistenteException,SQLException;
	
	
}
