package util;


import exceptions.*;

import java.util.Vector;
import java.sql.SQLException;



public interface ICadastroMensagem {

	
	
	public boolean existeMensagem(int id) throws SQLException;
		
	public Mensagem procurarMensagem(int id) throws MensagemNaoExistenteException,SQLException;
	
		
	public Vector getMensagensPrivada(int id_usuario) throws SQLException;
	
	public Vector getComentariosProjeto(int id_projeto) throws SQLException;
	
	public Vector getRecadosProjeto(int id_projeto) throws SQLException;
	
	public Vector getMensagensTopico(int id_topico) throws SQLException ;
		
	
	public void atualizarMensagem(Mensagem m) throws ObjetoNuloException,MensagemNaoExistenteException,SQLException;
	
	public void deletarAutor(String login) throws ObjetoNuloException,UsuarioNaoExistenteException,SQLException;
	
	
		
	public Mensagem adicionarMensagem(Mensagem m)
	  throws ObjetoNuloException,AutorNaoExistenteException,SQLException;
	
	
	public Mensagem adicionarMensagemPrivada(int id_usuario, Mensagem m) 
	  throws ObjetoNuloException,AutorNaoExistenteException,SQLException;
	
	
	public Mensagem adicionarComentarioProjeto(int id_projeto, Mensagem m) 
	  throws ObjetoNuloException,AutorNaoExistenteException,SQLException;
	
	
	public Mensagem adicionarRecadoProjeto(int id_projeto, Mensagem m) 
	  throws ObjetoNuloException,AutorNaoExistenteException,SQLException;
	
	
	public void adicionarMensagemTopico(int id_topico, Mensagem m) 
	  throws ObjetoNuloException,AutorNaoExistenteException,SQLException;
	
	
	
	public void removerMensagem(int id_mensagem) 
	  throws MensagemNaoExistenteException,SQLException;
		
	
	public void removerMensagemPrivada(int id_usuario, int id_mensagem)
	  throws MensagemNaoExistenteException,SQLException;
	
	
	public void removerComentarioProjeto(int id_projeto, int id_mensagem)
	  throws MensagemNaoExistenteException,SQLException;
	
	
	public void removerRecadoProjeto(int id_projeto, int id_mensagem)
	  throws MensagemNaoExistenteException,SQLException;
		
		
	public void removerMensagemTopico(int id_topico, int id_mensagem)
	  throws MensagemNaoExistenteException,SQLException;		

}
