package util;


import java.sql.*;
import java.util.Vector;




public class RepositorioMensagem implements IRepositorioMensagem {
	
	
	private Connection con;
	
	
	
	public RepositorioMensagem(Connection c) {
		this.con = c;
	}


	
	
	public Mensagem adicionarMensagem(Mensagem m) throws SQLException {
		Statement stmt = this.con.createStatement();
		
		ResultSet rset = stmt.executeQuery("SELECT id_usuario FROM usuario WHERE login = '"+ m.getAutor() +"';");
		int id = -1;
		if(rset.next()) id = rset.getInt(1);
		
		stmt.executeUpdate("INSERT INTO mensagem (data,data_edicao,corpo,id_usuario) VALUES (now(),now(),'"+
				           m.getCorpo() +"',"+ id +");" );
				
		rset = stmt.executeQuery("SELECT MAX(id_message) FROM mensagem;");
		if(!rset.next()) return null;
		id = rset.getInt(1);
		
		
		rset = stmt.executeQuery("SELECT * FROM mensagem WHERE id_message = "+ id +";");
		if(!rset.next()) return null;
		m.setID(rset.getInt(1));
		m.setData(rset.getString(2));
		m.setEditado(rset.getString(3));
		stmt.close();
		
		return m;
	}
	
	
	public void adicionarMensagemPrivada(int id_usuario, int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("INSERT INTO mensagemPrivada (id_message,id_usuario) VALUES ("
				           + id_mensagem +","+ id_usuario +");");
		stmt.close();
	}
	
	
	public void adicionarComentarioProjeto(int  id_projeto, int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("INSERT INTO comentarioProjeto (id_message,id_projeto) VALUES ("
				           + id_mensagem +","+ id_projeto +");");
		stmt.close();
	}
	
	
	public void adicionarRecadoProjeto(int  id_projeto, int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("INSERT INTO avisoProjeto (id_message,id_projeto) VALUES ("
				           + id_mensagem +","+ id_projeto +");");
		stmt.close();
	}
	
	
	public void adicionarMensagemTopico(int id_topico, int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("INSERT INTO mensagemTopico (id_message,id_topico) VALUES ("
				            + id_mensagem +","+ id_topico +");");
		stmt.close();
	}	
		
	
	public void atualizarMensagem(Mensagem m) throws SQLException {
		Statement stmt = this.con.createStatement();
		stmt.executeUpdate("UPDATE mensagem SET data_edicao = now(),corpo = '" + m.getCorpo() +
				           "' WHERE id_message = "+ m.getID() +";");
		stmt.close();
	}
	
	
	
	public void deletarAutorMensagem(String login) throws SQLException {
		Statement stmt = this.con.createStatement();
		
        ResultSet rset = stmt.executeQuery("SELECT id_usuario FROM usuario WHERE login = '" + login +"';");
        if(!rset.next()) return;
        int id_usuario = rset.getInt(1);
        		
		stmt.executeUpdate("UPDATE mensagem SET id_usuario = -1 WHERE id_usuario = " + id_usuario + ";");
		stmt.close();
		}
	
		
	
	public Mensagem procurarMensagem(int id) throws SQLException {
		Statement stmt = con.createStatement();
		ResultSet rset = stmt.executeQuery("SELECT * FROM mensagem WHERE id_message = "+ id +";");		 
				
		if(!rset.next()) return null;
		int id_mensagem = rset.getInt(1);
    	String data = rset.getString(2);
    	String edit = rset.getString(3);
    	String corpo = rset.getString(4);
    	int id_usuario = rset.getInt(5);  
    	
    	rset = stmt.executeQuery("SELECT login FROM usuario WHERE id_usuario = "+ id_usuario +";");
    	String autor = "#ANONIMO#";
    	if(rset.next()) autor = rset.getString(1);
    	stmt.close();
    	
    	return new Mensagem(id_mensagem,autor,corpo,data,edit);	
	}
		
	
	public Vector getMensagensPrivada(int id_usuario) throws SQLException {
		Statement stmt = con.createStatement();
		ResultSet rset;
		int id_mensagem;
		Vector mp = new Vector();
		
		rset = stmt.executeQuery("SELECT mensagem.id_message FROM mensagemprivada,mensagem WHERE mensagem." +
				                 "id_message = mensagemprivada.id_message AND mensagemprivada.id_usuario = " + 
				                 id_usuario +" ORDER BY mensagem.data;");
		while(rset.next()) {
        	id_mensagem = rset.getInt(1);
        	mp.addElement(this.procurarMensagem(id_mensagem));
        }
		stmt.close();		
        return mp;
	}
	
	
	public Vector getComentariosProjeto(int id_projeto) throws SQLException {
		Statement stmt = con.createStatement();
		ResultSet rset;
		int id_mensagem;
		Vector comen = new Vector();
		
		rset = stmt.executeQuery("SELECT mensagem.id_message FROM comentarioprojeto,mensagem WHERE mensagem."+
				                 "id_message = comentarioprojeto.id_message AND comentarioprojeto.id_projeto = "+ 
				                 id_projeto +" ORDER BY mensagem.data;");
		while(rset.next()) {
        	id_mensagem = rset.getInt(1);
        	comen.addElement(this.procurarMensagem(id_mensagem));
        }
		stmt.close();		
        return comen;
	}
	
	
	public Vector getRecadosProjeto(int id_projeto) throws SQLException { 
		Statement stmt = con.createStatement();
		ResultSet rset;
		int id_mensagem;
		Vector rec = new Vector();
		
		rset = stmt.executeQuery("SELECT mensagem.id_message FROM avisoprojeto,mensagem WHERE mensagem."+
				                 "id_message = avisoprojeto.id_message AND avisoprojeto.id_projeto = "+ 
				                 id_projeto +" ORDER BY mensagem.data;");
		while(rset.next()) {
        	id_mensagem = rset.getInt(1);
        	rec.addElement(this.procurarMensagem(id_mensagem));
        }
		stmt.close();		
        return rec;
	}
	
	
	public Vector getMensagensTopico(int id_topico) throws SQLException {
		Statement stmt = con.createStatement();
		ResultSet rset;
		int id_mensagem;
		Vector top = new Vector();
		
		rset = stmt.executeQuery("SELECT mensagem.id_message FROM mensagemtopico,mensagem WHERE mensagem."+
				                 "id_message = mensagemtopico.id_message AND mensagemtopico.id_topico = "+ 
				                 id_topico +" ORDER BY mensagem.data;");
		while(rset.next()) {
        	id_mensagem = rset.getInt(1);
        	top.addElement(this.procurarMensagem(id_mensagem));
        }
		stmt.close();		
        return top;
	}
	
	
	
	
	public void removerMensagem(int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM mensagem  WHERE id_message = " + id_mensagem + ";" );	
		stmt.close();
	}
	
	
	public void removerMensagemPrivada(int id_usuario,int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM mensagemPrivada  WHERE id_message = " + id_mensagem + ";" );	
		stmt.close();		
	}
	
	
	public void removerComentarioProjeto(int id_projeto,int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM comentarioProjeto  WHERE id_message = " + id_mensagem + ";" );	
		stmt.close();
	}
	
	
	public void removerRecadoProjeto(int id_projeto,int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM avisoProjeto  WHERE id_message = " + id_mensagem + ";" );	
		stmt.close();		
	}
		
	
	public void removerMensagemTopico(int id_topico,int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM mensagemTopico  WHERE id_message = " + id_mensagem + ";" );	
		stmt.close();
	}
	
	
	
	public static void main(String args[]) {
		
		try {
			Class.forName("org.gjt.mm.mysql.Driver");        
		    Connection con = DriverManager.getConnection("jdbc:mysql://localhost/devware","root","cinferno");

			RepositorioMensagem rep = new RepositorioMensagem(con);
			Mensagem m = new Mensagem("pabv","Eu nao tenho o q fazer e fico fazendo besteira");
						
			m = rep.adicionarMensagem(m);
		    m = rep.procurarMensagem(m.getID());
			if(m == null) System.out.println("null");
			else    System.out.println(""+  m.getAutor()+"    "+m.getCorpo());
			
			
		}
		catch(Exception e) {
			e.printStackTrace();			
		}
		
		
	}
	
	
}
